/* librarly for CAMAC access

*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>

#include "nbbqccio.h"


#define CNAFGEN(c,n,a,f) (0x00073fff & (c<<16 | (n-1)<<9 | a <<5 | f))

static int nbbqccio_fd = -1;
unsigned int arg[10];

int init_nbbqccio(void){
  int try = 0;

  while((nbbqccio_fd = open("/dev/nbbqccio", O_RDWR)) < 0){
    usleep(100000);
    try ++;
    if(try > 10){
      printf("Can't open /dev/nbbqccio\n");
    }
  }

  return 0;
}

int release_nbbqccio(void){
  if(nbbqccio_fd < 0){
    return -1;
  }else{
    close(nbbqccio_fd);
  }

  return 0;
}

unsigned int cc_raed24(int c, int n, int a, int f){
  int mode = NBBQCCIO_READ24;
  arg[0] = CNAFGEN(c, n, a, f);
  ioctl(nbbqccio_fd, mode, arg);
  return arg[1];
}

unsigned short cc_raed16(int c, int n, int a, int f){
  int mode = NBBQCCIO_READ16;
  arg[0] = CNAFGEN(c, n, a, f);
  ioctl(nbbqccio_fd, mode, arg);
  return (unsigned short)arg[1];
}

void cc_write24(int c, int n, int a, int f, int val){
  int mode = NBBQCCIO_WRITE24;
  arg[0] = CNAFGEN(c, n, a, f);
  arg[1] = (unsigned int)val;
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_write16(int c, int n, int a, int f, short val){
  int mode = NBBQCCIO_WRITE16;
  arg[0] = CNAFGEN(c, n, a, f);
  arg[1] = (unsigned int)val;
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_ctrl(int c, int n, int a, int f){
  int mode = NBBQCCIO_CTRL;
  arg[0] = CNAFGEN(c, n, a, f);
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_z(int c){
  int mode = NBBQCCIO_Z;
  arg[0] = c;
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_c(int c){
  int mode = NBBQCCIO_C;
  arg[0] = c;
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_define_lam(int n){
  int mode = NBBQCCIO_DEFINE_LAM;
  arg[0] = n;
  ioctl(nbbqccio_fd, mode, arg);
}

unsigned int cc_check_lam(void){
  int mode = NBBQCCIO_CHECK_LAM;
  arg[0] = 0;
  ioctl(nbbqccio_fd, mode, arg);
  return arg[0];
}

void cc_enable_interrupt(void){
  int mode = NBBQCCIO_ENABLE_INTERRUPT;
  arg[0] = 0;
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_disable_interrupt(void){
  int mode = NBBQCCIO_ENABLE_INTERRUPT;
  arg[0] = 0;
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_set_inhibit(int c){
  int mode = NBBQCCIO_SETI;
  arg[0] = c;
  ioctl(nbbqccio_fd, mode, arg);
}

void cc_claer_inhibit(int c){
  int mode = NBBQCCIO_DELI;
  arg[0] = c;
  ioctl(nbbqccio_fd, mode, arg);
}
